# config.rb - A Config module for Ruby by Ian Macdonald <ian@google.com>
#
# $Id: //depot/ops/corp/grhat/tree/usr/lib/ruby/site_ruby/config.rb#1 $

class Config
  def Config.parse(file, vars=nil)
    File.open(file) do |f|
      f.each do |line|
	next if line =~ /^(#|$)/  # ignore comments and blank lines
	var, val = /^(\S+)\s*=\s*(.+)$/.match(line)[1,2]
	if val == "0" || val.to_i > 0
	  # assign RHS to LHS as an integer
	  Object.const_set(var, val.to_i)
	else
	  # assign RHS to LHS as a string
	  Object.const_set(var, val)
	end
	#$stderr.printf "%s = %s\n", var.to_s, eval(var.to_s) if $DEBUG
      end

      # check all required vars were set
      vars.each do |var|
	begin
	  # assign the value of each symbol to val
	  # an exception means that symbol has no corresponding value
	  val = Object.const_get(var)
	rescue NameError
	  return var
	end
      end

      nil
    end
  end
end
